local f = CreateFrame("Frame")
f:SetPoint("TOPLEFT", 600, -75)
f:SetSize(200, 50)
local text = f:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
text:SetPoint("TOPLEFT", 0, 0)
local marked = {}
local slaves = {}
local felPlayers = {}
local lightPlayers = {}
local tanks = {}
local healers = {}
local dps = {}
local master = ""
local player = UnitName("player")
local init = false
RegisterAddonMessagePrefix("EnRT_MOV")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ENCOUNTER_START" then
		local eID = ...
		if eID == 2052 then
			master = EnRT_GetRaidLeader()
			for i = 2, GetNumGroupMembers()+1 do
				local raider = UnitName("raid"..i)
				if i == GetNumGroupMembers()+1 then
					raider = UnitName("raid1")
				end
				local role = UnitGroupRolesAssigned(raider)
				if role == "TANK" then
					tanks[#tanks+1] = raider
				elseif role == "HEALER" then
					healers[#healers+1] = raider
				else
					dps[#dps+1] = raider
				end
			end
		end
	elseif event == "UNIT_AURA" then
		local unit = ...
		local name = UnitName(unit)
		if UnitDebuff(name, GetSpellInfo(235213)) and not EnRT_Contains(lightPlayers, name) then
			lightPlayers[#lightPlayers+1] = name
		elseif EnRT_Contains(lightPlayers, name) then
			lightPlayers[EnRT_Contains(lightPlayers, name)] = nil
		end
		if UnitDebuff(name, GetSpellInfo(235240)) and not EnRT_Contains(felPlayers, name) then
			felPlayers[#felPlayers+1] = name
		elseif EnRT_Contains(felPlayers, name) then
			felPlayers[EnRT_Contains(felPlayers, name)] = nil
		end
		if UnitDebuff(name, GetSpellInfo(248812)) and not init then
			init = true
			EnRT_MOV_AssignGroups()
			C_Timer.After(12, function() init = false end)
		end
	end
end)

function EnRT_MOV_AssignGroups()
	local lgks = 0
	local lforwards = 0
	local lstandbys = 0
	local fgks = 0
	local fforwards = 0
	local fstandbys = 0
	for k,v in pairs(tanks) do
		if EnRT_Contains(lightPlayers, v) then
			fgks = fgks + 1
			SetRaidTarget(v, 7) -- Sets purple (Middle lane) Fel Side
		elseif EnRT_Contains(felPlayers, v) then
			lgks = lgks + 1
			SetRaidTarget(v, 2) -- Sets Purple (Middle lane)
		end
	end
	for k,v in pairs(healers) do
		if EnRT_Contains(lightPlayers, v) and fgks < 3 then
			fgks = fgks + 1
			if fgks == 2 then
				SetRaidTarget(v, 6)
			elseif fgks == 3 then
				SetRaidTarget(v, 8)
			end
		end
	end
end

function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end